using Godot;
using System;

public class Berry : Area2D
{
    Node playerVariables;
    AnimationPlayer animationPlayer;

    PackedScene audioStreamPlayer;
    AudioStreamSample asPickup;
    bool picked = false;

    float time = 0.0f;
    [Export]
    float speed = 5f;
    [Export]
    float power = 0.1f;

    public override void _Ready()
    {
        playerVariables = GetNode<Node>("/root/PlayerVariables");
        animationPlayer = GetNode<AnimationPlayer>("AnimationPlayer");

        audioStreamPlayer = (PackedScene)ResourceLoader.Load("res://Sound/AudioStreamPlayer.tscn");
        asPickup = (AudioStreamSample)ResourceLoader.Load("res://Sound/berry_pickup.wav");

        animationPlayer.Play("Idle");
    }

    public override void _PhysicsProcess(float delta)
    {
        time = Mathf.Wrap(time + delta * speed, -Mathf.Pi, Mathf.Pi);
        GlobalPosition = new Vector2(GlobalPosition.x, GlobalPosition.y + (Mathf.Sin(time) * power));
    }

    public void onBerryBodyEntered(KinematicBody2D player)
    {
        if (!picked)
        {
            picked = true;
            playerVariables.Call("IncBerries");
            animationPlayer.Play("Picked");
            PlaySound(asPickup);
        }

    }

    public void Delete()
    {
        QueueFree();
    }


    public void PlaySound(AudioStreamSample sample)
    {
        AudioStreamPlayer asp = (AudioStreamPlayer)audioStreamPlayer.Instance();
        asp.Stream = sample;
        GetTree().CurrentScene.AddChild(asp);
    }

}
