using Godot;
using System;

public class BerryCounter : Node2D
{
    Node playerVariables;
    Label label;
    Tween tween;
    Timer visibilityTimer;

    int MAX_VALUE = 22;

    public override void _Ready()
    {
        playerVariables = GetNode<Node>("/root/PlayerVariables");
        label = GetNode<Label>("Counter");
        tween = GetNode<Tween>("Tween");
        visibilityTimer = GetNode<Timer>("VisibilityTimer");

        playerVariables.Connect("berriesChangedSignal", this, "onBerriesChangedSignal");

        this.Modulate = new Color(1, 1, 1, 0);
    }


    public void onBerriesChangedSignal(int value)
    {
        label.Text = value + "/" + MAX_VALUE;
        this.Modulate = new Color(1, 1, 1, 1);
        visibilityTimer.Start(3);
    }

    public void onVisibilityTimerTimeout()
    {
        tween.InterpolateProperty(this, "modulate", new Color(1, 1, 1, 1), new Color(1, 1, 1, 0), 1, Tween.TransitionType.Linear, Tween.EaseType.In);
        tween.Start();
    }

}

