using Godot;
using System;

public class BossDoors : StaticBody2D
{
    CollisionShape2D collisionShape;

    Area2D playerDetection;
    AnimationPlayer animationPlayer;
    PackedScene dustParticles;
    KinematicBody2D bossClawDemon;

    public override void _Ready()
    {
        collisionShape = GetNode<CollisionShape2D>("CollisionShape");
        playerDetection = GetParent().GetNode<Area2D>("./PlayerDetectionBossTrigger");
        animationPlayer = GetNode<AnimationPlayer>("AnimationPlayer");
        dustParticles = (PackedScene)ResourceLoader.Load("res://Particles/FootStepsParticle.tscn");
        bossClawDemon = GetParent().GetNode<KinematicBody2D>("BossClawDemon");

        collisionShape.SetDeferred("disabled", true);

        playerDetection.Connect("playerEnteredBossAlertSignal", this, "openTheGate");
        bossClawDemon.Connect("bossKilledOpenTheGateSignal", this, "closeTheGate");

    }

    public void MakeDustParticle()
    {
        Particles2D dust1 = (Particles2D)dustParticles.Instance();
        Particles2D dust2 = (Particles2D)dustParticles.Instance();
        Particles2D dust3 = (Particles2D)dustParticles.Instance();
        dust1.GlobalPosition = new Vector2(GlobalPosition.x - 7, GlobalPosition.y + 46);
        dust2.GlobalPosition = new Vector2(GlobalPosition.x, GlobalPosition.y + 46);
        dust3.GlobalPosition = new Vector2(GlobalPosition.x + 7, GlobalPosition.y + 46);
        dust1.Emitting = true;
        dust2.Emitting = true;
        dust3.Emitting = true;
        GetParent().AddChild(dust1);
        GetParent().AddChild(dust2);
        GetParent().AddChild(dust3);
    }

    public void openTheGate()
    {
        collisionShape.SetDeferred("disabled", false);
        animationPlayer.Play("Close");
    }

    public void closeTheGate()
    {
        collisionShape.SetDeferred("disabled", true);
        animationPlayer.Play("Open");
    }

}
