using Godot;
using System;

public class BreakableWall : StaticBody2D
{
    AnimationPlayer animationPlayer;
    CollisionShape2D wallCollision;
    PackedScene audioStreamPlayer;
    AudioStreamSample asBreak;
    bool destroyed = false;

    public override void _Ready()
    {
        animationPlayer = GetNode<AnimationPlayer>("AnimationPlayer");
        wallCollision = GetNode<CollisionShape2D>("WallCollision");

        audioStreamPlayer = (PackedScene)ResourceLoader.Load("res://Sound/AudioStreamPlayer.tscn");
        asBreak = (AudioStreamSample)ResourceLoader.Load("res://Sound/breakable_doors.wav");
    }

    public void onHurtboxAreaEntered(Area2D area)
    {
        if (!destroyed)
        {
            destroyed = true;
            wallCollision.SetDeferred("disabled", true);
            animationPlayer.Play("Destroy");
            PlaySound(asBreak);
        }

    }

    public void Delete()
    {
        QueueFree();
    }

    public void PlaySound(AudioStreamSample sample)
    {
        AudioStreamPlayer asp = (AudioStreamPlayer)audioStreamPlayer.Instance();
        asp.Stream = sample;
        GetTree().CurrentScene.AddChild(asp);
    }
}
