using Godot;
using System;

public class CheckpointFountain : Area2D
{
    Node playerVariables;
    Label label;
    Tween tween;
    PackedScene audioStreamPlayer;
    AudioStreamSample asSaved;

    public override void _Ready()
    {
        playerVariables = GetNode<Node>("/root/PlayerVariables");
        label = GetNode<Label>("Label");
        tween = GetNode<Tween>("Tween");
        audioStreamPlayer = (PackedScene)ResourceLoader.Load("res://Sound/AudioStreamPlayer.tscn");
        asSaved = (AudioStreamSample)ResourceLoader.Load("res://Sound/checkpoint.wav");

        label.Visible = false;
    }

    public void PlaySound(AudioStreamSample sample)
    {
        AudioStreamPlayer asp = (AudioStreamPlayer)audioStreamPlayer.Instance();
        asp.Stream = sample;
        GetTree().CurrentScene.AddChild(asp);
    }

    public void onCheckpointFountainBodyEntered(KinematicBody2D body)
    {
        if ((int)playerVariables.Get("CheckpointLevel") != (int)playerVariables.Get("Level"))
        {
            saveCheckpointData();
            label.Visible = true;
            tween.InterpolateProperty(label, "margin_top", label.MarginTop, label.MarginTop - 20, 2, Tween.TransitionType.Linear, Tween.EaseType.In);
            tween.InterpolateProperty(label, "modulate", new Color(1, 1, 1, 1), new Color(1, 1, 1, 0), 2, Tween.TransitionType.Linear, Tween.EaseType.In);
            tween.Start();
            PlaySound(asSaved);
        }
    }

    public void saveCheckpointData()
    {
        playerVariables.Set("CheckpointLevel", playerVariables.Get("Level"));
        playerVariables.Set("CheckpointKills", playerVariables.Get("Kills"));
        playerVariables.Set("CheckpointBerries", playerVariables.Get("Berries"));
        playerVariables.Set("CheckpointSwordDamage", playerVariables.Get("SwordDamage"));
        playerVariables.Call("SaveData");
    }

}