using Godot;
using System;

public class FallingRock : KinematicBody2D
{
    KinematicBody2D playerBody;
    Vector2 upVector = new Vector2(0, -1);
    Vector2 motion = new Vector2(0, 0);
    int initialSpeed = 100;
    int gravity = 200;
    const int MAX_SPEED = 200;

    float velocity;

    public override void _Ready()
    {
        playerBody = GetParent().GetNode<KinematicBody2D>("./Player");
        velocity = initialSpeed;

        playerBody.Connect("lastLevelResetSignal", this, "onLastLevelResetSignal");
    }

    public override void _PhysicsProcess(float delta)
    {
        Gravity(delta);
        GlobalPosition += new Vector2(0, velocity * delta);
    }

    public void Gravity(float delta)
    {
        velocity = velocity + gravity * delta;
        if (velocity > MAX_SPEED)
        {
            velocity = MAX_SPEED;
        }
    }

    public void onVisibilityNotifierScreenExited()
    {
        QueueFree();
    }

    public void onLastLevelResetSignal()
    {
        QueueFree();
    }

}
