using Godot;
using System;

public class LavaTriggerArea : Area2D
{
    Camera2D camera2D;
    CanvasLayer playerUI;
    Node playerStats;

    bool lavaTriggered = false;

    [Signal] public delegate void playerEnteredZoneSignal();


    public override void _Ready()
    {
        camera2D = GetParent().GetNode<Camera2D>("../Player/PlayerCamera");
        playerUI = GetParent().GetNode<CanvasLayer>("../UI");
        playerStats = GetParent().GetNode<KinematicBody2D>("../Player").GetNode<Node>("Stats");
    }


    public void onLavaTriggerAreaBodyEntered(KinematicBody2D player)
    {
        if (!lavaTriggered)
        {
            lavaTriggered = true;
            this.EmitSignal(nameof(playerEnteredZoneSignal));
            camera2D.Call("StartShake", 3, 0.02f, 1, 2);
            playerUI.Layer = -1;
            playerStats.Set("Souls", 0);
            playerStats.Set("Health", 5);
        }
    }

}
