using Godot;
using System;

public class Mushroom : Node2D
{
    Sprite sprite;
    Random r = new Random();

    Particles2D p1;
    Particles2D p2;
    Particles2D p3;
    Particles2D p4;
    Particles2D p5;
    Particles2D p6;
    Particles2D p7;
    Timer deleteTimer;

    public override void _Ready()
    {
        p1 = GetNode<Particles2D>("CanvasLayer/Particles01");
        p2 = GetNode<Particles2D>("CanvasLayer/Particles02");
        p3 = GetNode<Particles2D>("CanvasLayer/Particles03");
        p4 = GetNode<Particles2D>("CanvasLayer/Particles04");
        p5 = GetNode<Particles2D>("CanvasLayer/Particles05");
        p6 = GetNode<Particles2D>("CanvasLayer/Particles06");
        p7 = GetNode<Particles2D>("CanvasLayer/Particles07");
        deleteTimer = GetNode<Timer>("DeleteTimer");

        sprite = GetNode<Sprite>("Sprite");

        sprite.Frame = r.Next(0, 14);
    }


    public void onMushroomAreaEntered(Area2D area)
    {

        int frameIndex = sprite.Frame;

        if (frameIndex == 0)
        {
            MakeDestroyParticle(p1).GlobalPosition = this.GlobalPosition + new Vector2(0, 6);
        }
        else if (frameIndex == 1 || frameIndex == 2)
        {
            MakeDestroyParticle(p2).GlobalPosition = this.GlobalPosition;
        }
        else if (frameIndex == 3)
        {
            MakeDestroyParticle(p3).GlobalPosition = this.GlobalPosition + new Vector2(0, -2);
        }
        else if (frameIndex >= 4 && frameIndex <= 6)
        {
            MakeDestroyParticle(p4).GlobalPosition = this.GlobalPosition + new Vector2(0, 3);
        }
        else if (frameIndex >= 7 && frameIndex <= 10)
        {
            MakeDestroyParticle(p5).GlobalPosition = this.GlobalPosition + new Vector2(-1, 2);
        }
        else if (frameIndex == 11)
        {
            MakeDestroyParticle(p6).GlobalPosition = this.GlobalPosition + new Vector2(0, 2);
        }
        else if (frameIndex == 12 || frameIndex == 13)
        {
            MakeDestroyParticle(p7).GlobalPosition = this.GlobalPosition + new Vector2(0, 5);
        }

        sprite.Visible = false;
        deleteTimer.Start(2);
    }


    public Particles2D MakeDestroyParticle(Particles2D pindex)
    {
        pindex.Emitting = true;

        return pindex;
    }

    public void onDeleteTimerTimeout()
    {
        QueueFree();
    }

}
