using Godot;
using System;
using System.Text.RegularExpressions;

public class NextLevel : Sprite
{
    Node playerVariables;
    KinematicBody2D player;
    Node stats;

    public override void _Ready()
    {
        playerVariables = GetNode<Node>("/root/PlayerVariables");
        player = GetTree().CurrentScene.GetNode<KinematicBody2D>("Player");
        stats = player.GetNode<Node>("Stats");
    }


    public void onHitboxBodyEntered(KinematicBody2D body)
    {
        UpdateScore();
        string scenePath = "res://Levels/Level_" + (GetLevelNumber() + 1).ToString() + ".tscn";
        File file = new File();
        if (file.FileExists(scenePath))
        {
            GetTree().ChangeScene(scenePath);
        }
    }

    public int GetLevelNumber()
    {
        string LevelName = GetTree().CurrentScene.Name;
        string LevelNumber = string.Empty;

        // for numbers with more than one digit
        var matches = Regex.Matches(LevelName, @"\d+");
        foreach (var match in matches)
        {
            // string addition
            LevelNumber += match;
        }

        return int.Parse(LevelNumber);
    }

    public void UpdateScore()
    {
        playerVariables.Set("Health", stats.Get("Health"));
        playerVariables.Set("Souls", stats.Get("Souls"));
        playerVariables.Set("Kills", stats.Get("Kills"));
    }

}
