using Godot;
using System;

public class PlayerDetectionBossTrigger : Area2D
{
    Timer playerNoInputTimer;
    CollisionShape2D collisionShape;
    KinematicBody2D player;

    [Signal] public delegate void playerEnteredBossAlertSignal();

    public override void _Ready()
    {
        playerNoInputTimer = GetNode<Timer>("PlayerNoInputTimer");
        collisionShape = GetNode<CollisionShape2D>("CollisionShape2D");
    }

    public void onPlayerDetectionBodyEntered(KinematicBody2D body)
    {
        player = body;
        this.EmitSignal(nameof(playerEnteredBossAlertSignal));
        player.Set("state", 10);
        playerNoInputTimer.Start(5);
        collisionShape.SetDeferred("disabled", true);
    }

    public void onPlayerNoInputTimerTimeout()
    {
        player.Set("state", 0);
    }

}
